#DEFINE dcComment					<COMMENT>
*</comment>
#DEFINE dcHungarianFirst_Para		't'					&& First letter to browse for hungarian notation on PARAMETERS
#DEFINE dcHungarianFirst_Prop		'l'					&& First letter to set for hungarian notation on properties
*note that the following will be used for properties second letter too
#DEFINE dcHungarianSecond_Array		'a'					&& Second letter to browse for hungarian notation on PARAMETERS "array"
#DEFINE dcType_Array				'Array'				&& String to put in Paras type attribut marking an array
#DEFINE dcHungarianSecond_Char		'c'					&& Second letter to browse for hungarian notation on PARAMETERS "character"
#DEFINE dcType_Char					'Character'			&& String to put in Paras type attribut marking a character var
#DEFINE dcHungarianSecond_Date		'd'					&& Second letter to browse for hungarian notation on PARAMETERS "date"
#DEFINE dcType_Date					'Date'				&& String to put in Paras type attribut marking a date var
#DEFINE dcHungarianSecond_Int		'i'					&& Second letter to browse for hungarian notation on PARAMETERS "integer"
#DEFINE dcType_Int					'Integer'			&& String to put in Paras type attribut marking an integer
#DEFINE dcHungarianSecond_Bool		'l'					&& Second letter to browse for hungarian notation on PARAMETERS "boolean"
#DEFINE dcType_Bool					'Boolean'			&& String to put in Paras type attribut marking a boolean var
#DEFINE dcHungarianSecond_Num		'n'					&& Second letter to browse for hungarian notation on PARAMETERS "numeric"
#DEFINE dcType_Num					'Numeric'			&& String to put in Paras type attribut marking a numeric var
#DEFINE dcHungarianSecond_Obj		'o'					&& Second letter to browse for hungarian notation on PARAMETERS "object"
#DEFINE dcType_Obj					'Object'			&& String to put in Paras type attribut marking an object var
#DEFINE dcHungarianSecond_Time		't'					&& Second letter to browse for hungarian notation on PARAMETERS "time"
#DEFINE dcType_Time					'DateTime'			&& String to put in Paras type attribut marking a time var
#DEFINE dcHungarianSecond_Variant	'v'					&& Second letter to browse for hungarian notation on PARAMETERS "variant"
#DEFINE dcType_Variant				'Variant'			&& String to put in Paras type attribut marking a variant var
#DEFINE CRLF						CHR(13)+CHR(10)
#DEFINE dcCreator					'JvP GmbH'
PARAMETERS;
 tcVCX        AS CHARACTER,;
 tcDBF        AS CHARACTER,;
 tlOverWrite  AS BOOLEAN,;
 tlOrderTable AS BOOLEAN

LOCAL;
 lcFile,;
 lcVCX,;
 lcPDM,;
 lcHTML_File,;
 lcHTML_Class,;
 lcHTML_DIAP,;
 lcHTML_DIAMP,;
 lcHTML_CopyRight,;
 lcClass,;
 lcTemp1,;
 lnPEM,;
 lnMatch,;
 lnLoop1,;
 loRegExp,;
 loMatch

IF PCOUNT()=0 THEN
 tcVCX       = ''
 tcDBF       = ''
 tlOverWrite = .F.
ENDIF &&PCOUNT()=0

LOCAL ARRAY;
 laLine(1,4)

DO CASE
 CASE ISNULL(tcVCX)
  lcFile = .NULL.
 CASE EMPTY(tcVCX)
  lcFile = ""
 CASE tcVCX='?'
  lnOldMemo =SET("Memowidth")
  SET MEMOWIDTH TO 100
  ?'VCX2DIAMP conversion tool to create a PDM meta file from an vcx.'+CRLF+;
   'Usage:'+CRLF+;
   'VCX2DIAMP([tcVCX],[tcDBF],[tlOverWrite],[tlOrderTable])'+CRLF+;
   ' tcVCX: Classlib to read. IF .NULL. and tlOrderTable, only reordering will performed'+CRLF+;
   ' tcDBF: PDM Meta Data'+CRLF+;
   ' tlOverWrite: Overwrite old records. If false only new records will be appended.'+CRLF+;
   ' tlOrderTable: Reorder table'+CRLF+;
   ' All parameters are optional' FONT 'COURIER'
  SET MEMOWIDTH TO lnOldMemo
  RETURN
 CASE !FILE(tcVCX)
 OTHERWISE
  lcFile = tcVCX
ENDCASE

IF EMPTY(lcFile) THEN
 lcFile = GETFILE('VCX','','',0,'Classlib to extract into PDM DIA(M)P source')
ENDIF &&EMPTY(lcFile)

DO CASE
 CASE ISNULL(lcFile) AND tlOrderTable
 CASE ISNULL(lcFile)
  RETURN .F.
 CASE EMPTY(lcFile) OR !FILE(lcFile)
  RETURN .F.
ENDCASE

IF !ISNULL(lcFile) THEN
 IF USED('_PDM_VCX') THEN
  USE (lcFile) ALIAS _PDM_VCX IN _PDM_VCX
 ELSE &&USED('_PDM_VCX')
  USE (lcFile) ALIAS _PDM_VCX IN 0
 ENDIF &&USED('_PDM_VCX')
 SELECT _PDM_VCX

 lcVCX  = UPPER(JUSTFNAME(lcFile))
ENDIF &&!ISNULL(lcFile)


*Get PDM SOurce
IF EMPTY(tcDBF) THEN
 IF PEMSTATUS(_SCREEN,'gcPDMSource',5) THEN
  lcFile = _SCREEN.gcPDMSource
 ELSE &&PEMSTATUS(_SCREEN ...
  lcFile = ''
 ENDIF &&PEMSTATUS(_SCREEN ...
 IF !EMPTY(lcFile) AND MESSAGEBOX('Open DIA(M)P source '+lcFile+'?',4+32,'DIA(M)P source')=7 THEN
  lcFile = ''
 ENDIF &&!EMPTY(lcFile)   ...
ELSE &&EMPTY(tcDBF)
 lcFile = tcDBF
ENDIF &&EMPTY(tcDBF)
IF EMPTY(lcFile) THEN
 lcFile = GETFILE('DBF','','',0,'PDM DIA(M)P source')
ENDIF &&EMPTY(lcFile)
IF EMPTY(lcFile) THEN
 IF USED('_PDM_VCX') THEN
  USE IN _PDM_VCX
 ENDIF &&USED('_PDM_VCX')
 RETURN .F.
ENDIF &&EMPTY(lcFile)

IF !FILE(lcFile) THEN
 CREATE TABLE (lcFile) FREE;
  (lLocked   L,;
  cFile      C(240),;
  mParent    M,;
  cPEM       C(240),;
  mHTML      M,;
  tTimeStamp T)
 INDEX ON cFile             TAG _cFile
 INDEX ON PADR(mParent,239) TAG _mParent
 INDEX ON cPEM              TAG _cPEM
 INDEX ON lLocked           TAG _lLocked
 USE
 IF USED('_PDM_Source') THEN
  USE (lcFile) ALIAS _PDM_Source EXCLUSIVE IN _PDM_Source
 ELSE &&USED('_PDM_Source')
  USE (lcFile) ALIAS _PDM_Source EXCLUSIVE IN 0
 ENDIF &&USED('_PDM_Source')
ELSE &&!FILE(lcFile)
 IF USED('_PDM_Source') THEN
  USE (lcFile) ALIAS _PDM_Source EXCLUSIVE IN _PDM_Source
 ELSE &&USED('_PDM_Source')
  USE (lcFile) ALIAS _PDM_Source EXCLUSIVE IN 0
 ENDIF &&USED('_PDM_Source')
 SELECT _PDM_Source
 IF TYPE('_PDM_Source.lLocked')#'L' THEN
  ALTER TABLE (lcFile) ADD COLUMN lLocked L
 ENDIF &&TYPE('_PDM_Source.lLocked' ...
 IF TYPE('_PDM_Source.tTimeStamp')#'T' THEN
  ALTER TABLE (lcFile) ADD COLUMN tTimeStamp T
 ENDIF &&TYPE('_PDM_Source.tTimeStamp' ...
 IF TYPE('_PDM_Source.cFile')#'C' THEN
  DELETE TAG ALL
  ALTER TABLE (lcFile) ADD COLUMN cFile C(240)
  ALTER TABLE (lcFile) ADD COLUMN mParent M
  ALTER TABLE (lcFile) ADD COLUMN cPEM C(240)
  ALTER TABLE (lcFile) ADD COLUMN mHTML M

  REPLACE;
   cFile   WITH ClassLoc,;
   mParent WITH CLASS,;
   cPEM    WITH ObjName,;
   mHTML   WITH HTML;
   ALL

  ALTER TABLE (lcFile) DROP COLUMN ClassLoc
  ALTER TABLE (lcFile) DROP COLUMN CLASS
  ALTER TABLE (lcFile) DROP COLUMN ObjName
  ALTER TABLE (lcFile) DROP COLUMN HTML

  INDEX ON cFile             TAG _cFile
  INDEX ON PADR(mParent,239) TAG _mParent
  INDEX ON cPEM              TAG _cPEM
  INDEX ON lLocked           TAG _lLocked
 ENDIF &&TYPE('_PDM_Source.tTimeStamp' ...
ENDIF &&!FILE(lcFile)

_SCREEN.ADDPROPERTY('gcPDMSource',lcFile)
lcPDM = lcFile

IF USED('_PDM_VCX') THEN
TEXT TO lcHTML_CopyRight NOSHOW
<appliesto toref="0" toalso="0" />
<seealso>
 <see loca="" class="" pem=""></see>
</seealso>
</comment>
<copyright><i>&copy; <autodate /> dcCreator</i></copyright>
ENDTEXT

TEXT TO lcHTML_File NOSHOW TEXTMERGE
<descr></descr>
<remarks></remarks>
dcComment
<<lcHTML_CopyRight>>
ENDTEXT

TEXT TO lcHTML_Class NOSHOW TEXTMERGE
dcComment
<descr></descr>
<remarks></remarks>
<example></example>
<<lcHTML_CopyRight>>
ENDTEXT

TEXT TO lcHTML_DIAP NOSHOW TEXTMERGE
<descr></descr>
<propval name="" type="" dir="0"></propval>
dcComment
<syntax></syntax>
<remarks></remarks>
<example></example>
<<lcHTML_CopyRight>>
ENDTEXT

TEXT TO lcHTML_DIAMP NOSHOW TEXTMERGE
<descr></descr>
dcComment
<params name="" type="" byref="0" dir="" inb="0" outb="0">
<short></short>
<detail></detail>
</params>
<retval type=""></retval>
<remarks></remarks>
<example></example>
<<lcHTML_CopyRight>>
ENDTEXT

 Update_PDM(lcPDM,lcVCX,'','',lcHTML_File,tlOverWrite)

 loRegExp = CREATEOBJECT('VBScript.RegExp')
 loRegExp.IgnoreCase = .T.
 loRegExp.GLOBAL     = .T.
 loRegExp.MultiLine  = .T.

 SELECT _PDM_VCX
 SCAN FOR PLATFORM=="WINDOWS "
  lcClass = UPPER(PARENT)+IIF(EMPTY(PARENT),'','.')+UPPER(ObjName)
  Update_PDM(lcPDM,lcVCX,lcClass,'',lcHTML_Class,tlOverWrite)

*lets first excerpt all newly created Props and Methods.
*RUN through Reserved3 (Properties AND Methods)
  lcTemp1 = Reserved3
  lnPEM = 0
*All first words (without comment)
  loRegExp.PATTERN = "^[\*^]?\S*\b"
  loMatch          = loRegExp.Execute(lcTemp1)
  IF !EMPTY(loMatch.COUNT) THEN

   DIMENSION;
    laLine(lnPEM+loMatch.COUNT,4)
* Column
*   1		Class[.object].PEM
*	2		Class[.object]
*	3		PEM
*	4		DIA(M)P code
   FOR lnMatch = 1 TO loMatch.COUNT
*Procedure?
    laLine(lnPEM+lnMatch,2) = lcClass
    laLine(lnPEM+lnMatch,4) = IIF(SUBSTR(loMatch.ITEM(lnMatch-1).VALUE,1,1)=='*',lcHTML_DIAMP,lcHTML_DIAP)
&&Remove Prefixes marking Method hidden and so on
    loRegExp.PATTERN = "^[^\w]*"
    lcTemp1          = loRegExp.REPLACE(loMatch.ITEM(lnMatch-1).VALUE,'')
*Strip out Brackets marking an array
    loRegExp.PATTERN = "\[\S*\]?"
    laLine(lnPEM+lnMatch,3) = UPPER(loRegExp.REPLACE(lcTemp1,''))
    laLine(lnPEM+lnMatch,1) = laLine(lnPEM+lnMatch,2)+[.]+laLine(lnPEM+lnMatch,3)
   ENDFOR &&lnMatch
   lnPEM = lnPEM+loMatch.COUNT
  ENDIF &&!EMPTY(loMatch.COUNT)
*Get properties from Properties Field
  GET_Properties(loRegExp,lcClass,Properties,@lnPEM,@laLine,lcHTML_DIAP,lcHTML_CopyRight)
*Get procedures from Methods Field
  GET_Procedures(loRegExp,lcClass,Methods,@lnPEM,@laLine,lcHTML_DIAMP,lcHTML_CopyRight)
  FOR lnLoop1 = 1 TO lnPEM
   Update_PDM(lcPDM,lcVCX,UPPER(laLine(lnLoop1,2)),UPPER(laLine(lnLoop1,3)),IIF(EMPTY(laLine(lnLoop1,4)),lcHTML_DIAP,laLine(lnLoop1,4)),tlOverWrite)
  ENDFOR &&lnloop1
 ENDSCAN
 USE IN _PDM_VCX
ENDIF &&USED('_PDM_VCX')
IF tlOrderTable THEN
 Order_Table()
ENDIF &&tlOrderTable
USE IN _PDM_Source
RETURN

*!*	<pdm>
*!*	<descr>Read all defined and used classes, objects, methods and properties from a vcx and store into a PDM source table.</descr>
*!*	<params name="tcVCX" type="CHARACTER" byref="0" dir="In" inb="1" outb="1">
*!*	<short>Name of the VCX to analyse.</short>
*!*	<detail>VCX file to analyse.
*!*	If no file is given a dialog will ask for a vcx.
*!*	If this is <expr>.NULL.</expr> and <pdmpara num="4"/> is True the procedure will just call <see pem="Order_Table"/>
*!*	to run the reordering.</detail>
*!*	</params>
*!*	<params name="tcDBF" type="CHARACTER" byref="0" dir="" inb="1" outb="1">
*!*	<short>Table to store VCX info.</short>
*!*	<detail>To this table all info found in a vcx will be stored
*!*	If no file is given, there will a dialog.
*!*	If there is no file, a table will be generated.
*!*	The filename will be stored for subsequent use.</detail>
*!*	</params>
*!*	<params name="tlOverWrite" type="Boolean" byref="0" dir="" inb="1" outb="1">
*!*	<short>Overwrite not empty mHTML memo.</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tlOrderTable" type="Boolean" byref="0" dir="" inb="1" outb="1">
*!*	<short>Reorders the table. If <pdmpara num="1"/> is <expr>.NULL.</expr> there will be no scanning.</short>
*!*	<detail>Calls <see pem="Order_Table"/>
*!*	to run the reordering.</detail></detail>
*!*	</params>
*!*	<retval type="Boolean"></retval>
*!*	<remarks>False if no VCX or table is found.</remarks>
*!*	<example></example>
*!*	<remarks>The table will be created if non existend. The filename will be stored for subsequent use.<br />
*!*	Records newly created will locked for use with Agnes plug ins via lLocked field.</remarks>
*!*	<seealso>
*!*	 <see pem="GET_Properties">GET_Properties</see>
*!*	 <see pem="GET_Procedures"> GET_Procedures</see>
*!*	</seealso>
*!*	<comment>
*!*	<retval type=""></retval>
*!*	<example></example>
*!*	<appliesto toref="0" toalso="0" />
*!*	</comment>
*!*	<copyright><i>&copy;26.8.2004 JvP GmbH</i></copyright>
*!*	</pdm>

PROCEDURE GET_Properties
 PARAMETERS;
  toRegExp,;
  tcClass,;
  tcProperties,;
  tnPEM,;
  taLine,;
  tcHTML_DIAP,;
  tcHTML_CopyRight

 LOCAL ARRAY;
  laLines(1),;
  laProp(1)

 LOCAL;
  lcTemp1,;
  lcTemp2,;
  lcPEM,;
  lcClass,;
  lnLoop1,;
  lcProp,;
  lcType,;
  lcHTML

 FOR lnLoop1 = 1 TO ALINES(laLines,tcProperties)
  IF  ALINES(laProp,laLines(lnLoop1),.T.,' = ')>1 THEN
   lcTemp1 = laProp(1)
   lcTemp2 = tcClass+[.]+lcTemp1
   IF '.'$lcTemp1 THEN
    lcPEM   = JUSTEXT(lcTemp1)
    lcClass = tcClass+[.]+LEFT(lcTemp1,LEN(lcTemp1)-1-LEN(lcPEM))
   ELSE &&'.'$lcTemp1
    lcPEM = lcTemp1
    lcClass = tcClass
   ENDIF &&'.'$lcTemp1

   IF UPPER(lcPEM)=='NAME';
     OR UPPER(lcPEM)=='DOCREATE' THEN
    LOOP
   ENDIF &&UPPER(lcPEM ...

   lnRow   = ASCAN(taLine,lcTemp2,1,-1,1,8+1)
   IF EMPTY(lnRow) THEN
    tnPEM = tnPEM+1
    lnRow       = 1
    DIMENSION;
     taLine(tnPEM,4)
* Column
*   1		Class[.object].PEM
*	2		Class[.object]
*	3		PEM
*	4		DIA(M)P code
    AINS(taLine,1)
    taLine(lnRow,1) = lcTemp2
    taLine(lnRow,2) = lcClass
    taLine(lnRow,3) = lcPEM
   ENDIF &&EMPTY(lnRow)

   lcType  = laProp(2)
   lcType  = TYPE(lcType)
   DO CASE
    CASE lcType=='C'
     lcType = dcType_Char
     lcProp = dcHungarianFirst_Prop+dcHungarianSecond_Char+'PropVal'
    CASE lcType=='D'
     lcType = dcType_Date
     lcProp = dcHungarianFirst_Prop+dcHungarianSecond_Date+'PropVal'
    CASE lcType=='L'
     lcType = dcType_Bool
     lcProp = dcHungarianFirst_Prop+dcHungarianSecond_Bool+'PropVal'
    CASE lcType=='N'
     lcType = dcType_Num
     lcProp = dcHungarianFirst_Prop+dcHungarianSecond_Num+'PropVal'
    CASE lcType=='O'
     lcType = dcType_Obj
     lcProp = dcHungarianFirst_Prop+dcHungarianSecond_Obj+'PropVal'
    CASE lcType=='T'
     lcType = dcType_Time
     lcProp = dcHungarianFirst_Prop+dcHungarianSecond_Time+'PropVal'
    CASE lcType=='X'
     lcType = 'Null'
     lcProp = dcHungarianFirst_Prop+dcHungarianSecond_Variant+'PropVal'
    OTHERWISE
     lcType = 'Unknown'
     lcProp = dcHungarianFirst_Prop+dcHungarianSecond_Variant+'PropVal'
   ENDCASE

TEXT TO taLine(lnRow,4) NOSHOW TEXTMERGE
<descr></descr>
<propval name="<<lcProp>>" type="<<lcType>>" dir="0"></propval>
dcComment
<syntax></syntax>
<remarks></remarks>
<example></example>
<<tcHTML_CopyRight>>
ENDTEXT

  ENDIF &&ALINES(laProp,laLines(lnLoop1) ...
 ENDFOR &&lnLoop1
*!*	<pdm>
*!*	<descr>Get properties out of properties memo</descr>
*!*	<params name="toRegExp" type="Object" byref="0" dir="In" inb="0" outb="0">
*!*	<short>RegExp object for internal use</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tcClass" type="Character" byref="0" dir="In" inb="0" outb="0">
*!*	<short>Class that containes the Properties. For storage purposes.</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tcProperties" type="Character" byref="0" dir="In" inb="0" outb="0">
*!*	<short>Properties Memo of vcx</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tnPEM" type="Numeric" byref="1" dir="In and Out" inb="0" outb="0">
*!*	<short>Number of properties found</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="taLine" type="Array" byref="1" dir="In and out" inb="0" outb="0">
*!*	<short>Array containing information about properties.</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tcHTML_DIAP" type="Character" byref="0" dir="In" inb="0" outb="0">
*!*	<short>Preformated DIAP for mHTML memo with empty tags.</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tcHTML_CopyRight" type="Character" byref="0" dir="In" inb="0" outb="0">
*!*	<short>Preformated text for mHTML memo with empty tags appliesto, seealso and copyright.</short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks>The value of the property will be checked for its type. Types will be set to the output.
*!*	 See defines on top of this file for text.</remarks>
*!*	<example></example>
*!*	<appliesto auto="0" />
*!*	<seealso></seealso>
*!*	<copyright><i>&copy;2004 JvP GmbH</i></copyright>
*!*	</pdm>
ENDPROC &&GET_Properties

PROCEDURE GET_Procedures
 PARAMETERS;
  toRegExp,;
  tcClass,;
  tcMethod,;
  tnPEM,;
  taLine,;
  tcHTML_DIAMP,;
  tcHTML_CopyRight

 EXTERNAL ARRAY;
  taLine

 LOCAL ARRAY;
  laParas(1),;
  laPara(1)

 LOCAL;
  lcTemp1,;
  lcHTML,;
  lcPara,;
  lnMatch,;
  lnRow,;
  lnLoop1,;
  lnPara,;
  loMatch,;
  loMatchProc

*lets run through the methods and catch unknown ones
*also get Parameters
*thats the one to skip comment lines
*   toRegExp.PATTERN = "^[ \t]*((&"+"&)|(\*!\*)|\*|(NOTE))[^\n\r]*"
 toRegExp.PATTERN = "^[ \t]*(PROCEDURE)[^\n\r]*"
 loMatch          = toRegExp.Execute(tcMethod)
 IF !EMPTY(loMatch.COUNT) THEN
  FOR lnMatch = 1 TO loMatch.COUNT
&&Strip first word
   toRegExp.PATTERN = "^[ \t]*PROCEDURE "
   lcTemp1 = UPPER(toRegExp.REPLACE(loMatch.ITEM(lnMatch-1).VALUE,''))

   lcTemp2 = tcClass+[.]+lcTemp1
   IF '.'$lcTemp1 THEN
    lcPEM   = JUSTEXT(lcTemp1)
    lcClass = tcClass+[.]+LEFT(lcTemp1,LEN(lcTemp1)-1-LEN(lcPEM))
   ELSE &&'.'$lcTemp1
    lcPEM = lcTemp1
    lcClass = tcClass
   ENDIF &&'.'$lcTemp1

   lnRow   = ASCAN(taLine,lcTemp2,1,-1,1,8+1)
   lcHTML  = tcHTML_DIAMP
   IF EMPTY(lnRow) THEN
    tnPEM = tnPEM+1
    DIMENSION;
     taLine(tnPEM,4)
* Column
*   1		Class[.object].PEM
*	2		Class[.object]
*	3		PEM
*	4		DIA(M)P code

    taLine(tnPEM,1) = lcTemp2
    taLine(tnPEM,2) = lcClass
    taLine(tnPEM,3) = lcPEM
    lnRow           = tnPEM
   ENDIF &&EMPTY(lnRow)
*Get Procedure
   toRegExp.PATTERN = "^[ \t]*"+loMatch.ITEM(lnMatch-1).VALUE+"(([\s\S](?![ \t]*ENDPROC))*[\s\S])?[ \t]*ENDPROC"
   loMatchProc     = toRegExp.Execute(tcMethod)
   IF !EMPTY(loMatchProc.COUNT) THEN
*Name is unique so we are one single proc
*Strip &&; they will mixup a lot of things (let's hope no fool enters a semicolon behind &&)
    toRegExp.PATTERN = '&'+"&[^\r|\n]*"
    lcTemp1          = toRegExp.REPLACE(loMatchProc.ITEM(0).VALUE,'')
*Strip trailing spaces
    toRegExp.PATTERN = "\s*$"
    lcTemp1          = toRegExp.REPLACE(loMatchProc.ITEM(0).VALUE,'')
*Search for parameters (line)
    toRegExp.PATTERN = "^[ \t]*L?PARA(M(E(T(E(R(S)?)?)?)?)?)?(?![A-Za-z0-9_])[^\n\r]*"
    loMatchProc      = toRegExp.Execute(lcTemp1)
    IF !EMPTY(loMatchProc.COUNT) THEN
*only first params count
*first line with no continuation
     toRegExp.PATTERN = "[^;]$"
     lcTemp1          = SUBSTR(lcTemp1,loMatchProc.ITEM(0).Firstindex+1)
     loMatchProc      = toRegExp.Execute(lcTemp1)
     IF !EMPTY(loMatchProc.COUNT) THEN
      lcTemp1        = SUBSTR(lcTemp1,1,loMatchProc.ITEM(0).Firstindex+1)
*now we have Parameters with all params
*Remove keword (just the first one)
      toRegExp.PATTERN = "^[ \t]*L?PARA(M(E(T(E(R(S)?)?)?)?)?)?(?![A-Za-z0-9_])"
      loMatchProc      = toRegExp.Execute(lcTemp1)
      lcTemp1          = SUBSTR(lcTemp1,loMatchProc.ITEM(0).Firstindex+1+loMatchProc.ITEM(0).LENGTH)
*now we remove semicolon and linebreak and put all in one line
      toRegExp.PATTERN = "[;]$\s^"
      lcTemp1          = toRegExp.REPLACE(lcTemp1,' ')
*make all "as" uppercase
      lcTemp1          = STRTRAN(lcTemp1, 'as ',' AS ',1,-1,1)
      lcHTML           = ''
      FOR lnLoop1 = 1 TO ALINES( laParas,lcTemp1,.T.,',')
       lnPara = ALINES(laPara,laParas(lnLoop1),.T.,' AS ')
       IF lnPara<2 OR EMPTY(laPara(2)) THEN
*check for hungarian notation
        lcPara = SUBSTR(laPara(1),2,1)
        DO CASE
         CASE !SUBSTR(laPara(1),1,1)=dcHungarianFirst_Para
*not named as para
          lcPara = ''
         CASE lcPara==dcHungarianSecond_Array
          lcPara = dcType_Array
         CASE lcPara==dcHungarianSecond_Char
          lcPara = dcType_Char
         CASE lcPara==dcHungarianSecond_Date
          lcPara = dcType_Date
         CASE lcPara==dcHungarianSecond_Int
          lcPara = dcType_Int
         CASE lcPara==dcHungarianSecond_Bool
          lcPara = dcType_Bool
         CASE lcPara==dcHungarianSecond_Num
          lcPara = dcType_Num
         CASE lcPara==dcHungarianSecond_Obj
          lcPara = dcType_Obj
         CASE lcPara==dcHungarianSecond_Time
          lcPara = dcType_Time
         CASE lcPara==dcHungarianSecond_Variant
          lcPara = dcType_Variant
         OTHERWISE
          lcPara = ''
        ENDCASE
        lcPara = '"'+lcPara+'"'
       ELSE &&lnPara<2   ...
        lcPara = laPara(2)
        DO CASE
         CASE '"'$lcPara AND "'"$lcPara
          lcPara = '"'+STRTRAN(lcPara,'"',"'")+'"'
         CASE '"'$lcPara
          lcPara = "'"+lcPara+"'"
         OTHERWISE
          lcPara = '"'+lcPara+'"'
        ENDCASE
       ENDIF &&lnPara<2   ...
       lcPara = STRTRAN(lcPara,'>','&gt;')
TEXT TO lcHTML ADDITIVE TEXTMERGE NOSHOW
<params name="<<laPara(1)>>" type=<<lcPara>> byref="0" dir="" inb="0" outb="0">
<short></short>
<detail></detail>
</params>

ENDTEXT
      ENDFOR &&lnLoop1
      IF EMPTY(lcHTML) THEN
       lcHTML = tcHTML_DIAMP
      ELSE &&EMPTY(lcHTML)
       lcTemp1 = lcHTML
       lcHTML  = ''
TEXT TO lcHTML TEXTMERGE NOSHOW
<descr></descr>
<<lcTemp1>><retval type=""></retval>
<remarks></remarks>
dcComment
<example></example>
<<tcHTML_CopyRight>>
ENDTEXT

      ENDIF &&EMPTY(lcHTML)
     ENDIF &&!EMPTY(loMatchProc.COUNT)
    ENDIF &&!EMPTY(loMatchProc.COUNT)
   ENDIF &&!EMPTY(loMatchProc.COUNT)
   taLine(lnRow,4) = lcHTML
  ENDFOR &&lnMatch
 ENDIF &&!EMPTY(loMatch.COUNT)

*!*	<pdm>
*!*	<descr>Get methods out of method memo</descr>
*!*	<params name="toRegExp" type="Object" byref="0" dir="In" inb="0" outb="0">
*!*	<short>RegExp object for internal use</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tcParent" type="Character" byref="0" dir="In" inb="0" outb="0">
*!*	<short>Class that containes the methods. For storage purposes.</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tcMethod" type="Character" byref="0" dir="In" inb="0" outb="0">
*!*	<short>Methods Memo of vcx</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tnPEM" type="Numeric" byref="1" dir="In and Out" inb="0" outb="0">
*!*	<short>Number of methods found</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="taLine" type="Array" byref="1" dir="In and out" inb="0" outb="0">
*!*	<short>Array containing information about methods.</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tcHTML_DIAMP" type="Character" byref="0" dir="In" inb="0" outb="0">
*!*	<short>Preformated DIAMP for mHTML memo with empty tags.</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tcHTML_CopyRight" type="Character" byref="0" dir="In" inb="0" outb="0">
*!*	<short>Preformated text for mHTML memo with empty tags appliesto, seealso and copyright.</short>
*!*	<detail></detail>
*!*	</params>
*!*	<retval type=""></retval>
*!*	<remarks>This method test the methods for parameters and creates the &lt;params&gt; section.<br />
*!*	If the parameter follows a special hungarion notation, the typ field will be filled.<br />
*!*	See defines on top of the file for notaion chars and types. This may be altered.
*!*	</remarks>
*!*	<example></example>
*!*	<appliesto auto="0" />
*!*	<seealso></seealso>
*!*	<copyright><i>&copy;2004 JvP GmbH</i></copyright>
*!*	</pdm>
ENDPROC &&GET_Procedures

PROCEDURE Update_PDM
 PARAMETERS;
  tcSource,;
  tcFile,;
  tcParent,;
  tcPEM,;
  tcHTML,;
  tlOverWrite

 LOCAL;
  lnSelect

 lnSelect = SELECT()
 SELECT _PDM_Source

 IF LEN(tcParent)<241 THEN
  LOCATE FOR;
   UPPER(cFile)==PADR(tcFile,240);
   AND PADR(mParent,240)==PADR(tcParent,240);
   AND cPEM=PADR(tcPEM,240)
 ELSE
  LOCATE FOR;
   UPPER(cFile)==PADR(tcFile,240);
   AND mParent==tcParent;
   AND cPEM=PADR(tcPEM,240)
 ENDIF


 DO CASE
  CASE !FOUND()
   INSERT INTO (tcSource);
    (lLocked,cFile,mParent,cPEM,mHTML,tTimeStamp);
    VALUES;
    (.T.,tcFile,tcParent,tcPEM,tcHTML,DATETIME())
  CASE tlOverWrite
   REPLACE;
    mHTML      WITH tcHTML,;
    tTimeStamp WITH DATETIME()
  CASE EMPTY(mHTML)
   REPLACE;
    mHTML      WITH tcHTML,;
    tTimeStamp WITH DATETIME()
 ENDCASE

 SELECT (lnSelect)
*!*	<pdm>
*!*	<descr>Writes a description of a specified item to PDM souce table</descr>
*!*	<params name="tcSource" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short>DBF of PDM source "Meta Data" table</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tcFile" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short>File name</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tcParent" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short>Name Class[.Object]<sup>n</sup></short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tcPEM" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short>Name of Property / Event/ Method / Function / Procedure</short>
*!*	<detail>Special value "MAIN PROGRAM" marks that description in <pdmpara num="5" /> is for "main propram" of a prg file.</detail>
*!*	</params>
*!*	<params name="tcHTML" type="Character" byref="0" dir="" inb="0" outb="0">
*!*	<short>The description of item specified by <pdmpara num="2" />, <pdmpara num="3" /> and <pdmpara num="4" />.</short>
*!*	<detail></detail>
*!*	</params>
*!*	<params name="tlOverWrite" type="Boolean" byref="0" dir="" inb="0" outb="0">
*!*	<short>Overwrite old Values</short>
*!*	<detail></detail>
*!*	</params>
*!*	<comment>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*	 <see loca="" class="" pem=""></see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	</comment>
*!*	<copyright><i>&copy;26.8.2004 JvP GmbH</i></copyright>
*!*	</pdm>
ENDPROC &&Update_PDM

PROCEDURE Order_Table
 SELECT _PDM_Source
 PACK
 SELECT;
  Cur1.*,;
  PADR(mParent,240) AS cParent;
  FROM _PDM_Source AS Cur1;
  INTO CURSOR curOrder;
  ORDER BY cFile,cParent,cPEM
 SELECT _PDM_Source
 ZAP
 APPEND FROM DBF('curOrder')
 USE IN curOrder

*!*	<pdm>
*!*	<descr>Sortiert die Quelltabelle nach File,Object,PEM, packt die Datei.</descr>
*!*	<comment>
*!*	<retval type=""></retval>
*!*	<remarks></remarks>
*!*	<example></example>
*!*	<seealso>
*!*	 <see loca="" class="" pem=""></see>
*!*	</seealso>
*!*	<appliesto toref="0" toalso="0" />
*!*	</comment>
*!*	<copyright><i>&copy; 4.2.2005 JvP GmbH</i></copyright>
*!*	</pdm>
ENDPROC &&Order_Table
